<?php

/**
 * Adds container functionality
 * for connectable objects.
 */
abstract class Container extends Connectable {

  /**
   * This variable holds the items.
   *
   * @var array
   */
  protected $items = array();

  /**
   * Adds an item.
   *
   * @param mixed $item
   * @param mixed $key Optional.
   */
  public function add($item, $key = NULL) {
    if($key === NULL) {
      $this->items []= $item;
    } else {
      $this->items[$key] = $item;
    }
  }

  /**
   * Retrieves an item based on the key.
   *
   * @param mixed $key
   * @return mixed
   */
  public function get($key) {
    return isset($this->items[$key]) ? $this->items[$key] : NULL;
  }

  /**
   * Number of the items.
   *
   * @return int
   */
  public function size() {
    return count($this->items);
  }

  /**
   * Returns an iterator for the items.
   *
   * @return ArrayIterator
   */
  public function getIterator() {
    return new ArrayIterator($this->items);
  }
}